package org.syncloud.facade;

import org.syncloud.facade.dao.ConfigReader;
import org.syncloud.facade.dao.ConfigWriter;
import syncloud.core.log.Logger;
import syncloud.storage.UserConfig;

public class ConfigurationManager {

    private static Logger logger = Logger.getLogger(ConfigurationManager.class);
    private ConfigReader<UserConfig> reader;
    private ConfigWriter<UserConfig> writer;

    public ConfigurationManager(ConfigReader<UserConfig> reader, ConfigWriter<UserConfig> writer) {
        this.reader = reader;
        this.writer = writer;
    }

    public UserConfig getConfig() {
        UserConfig userConfig = reader.read();
        if (userConfig == null) userConfig = UserConfig.Default();

        return userConfig;
    }

    public void saveConfig(UserConfig userConfig) {
        writer.save(userConfig);
    }
}
