package org.syncloud.facade.dao;

import org.json.JSONException;
import org.syncloud.facade.dao.json.base.Reader;
import syncloud.core.CoreException;
import syncloud.core.log.Logger;

public class ConfigReader<T> {

    private static Logger logger = Logger.getLogger(ConfigReader.class);
    private org.syncloud.facade.dao.io.Reader reader;
    private Reader<String, T> parser;

    public ConfigReader(org.syncloud.facade.dao.io.Reader reader, Reader<String, T> parser) {
        this.reader = reader;
        this.parser = parser;
    }

    public T read() {

        T result = null;

        if (!reader.exists()) {
            return result;
        }

        try {
            String content = reader.read();
            result = parser.fromJson(content);
        } catch (JSONException e) {
            logger.error("unable to parse configuration file", e);
        } catch (CoreException e) {
            logger.error("will use empty config");
        }

        /*if (result == null)
            logger.info("config file is not found in: " + );*/

        return result;
    }

}
