package org.syncloud.facade.dao;

import org.json.JSONException;
import org.syncloud.facade.dao.io.FileWriter;
import org.syncloud.facade.dao.json.base.Writer;
import syncloud.core.log.Logger;

import java.io.IOException;

public class ConfigWriter<T> {
    private static Logger logger = Logger.getLogger(ConfigWriter.class);

    private final FileWriter writer;
    private final Writer<T, String> parser;

    public ConfigWriter(FileWriter writer, Writer<T, String> parser) {
        this.writer = writer;
        this.parser = parser;
    }

    public void save(T accounts) {
        try {
            String content = parser.toJson(accounts);
            writer.write(content);
        } catch (JSONException e) {
            logger.error("unable to parse config", e);
        } catch (IOException e) {
            logger.error("unable to write config", e);
        }
    }
}
