package org.syncloud.facade.dao;

import syncloud.core.CoreException;
import syncloud.storage.Sync;

import java.util.ArrayList;
import java.util.List;

public class SyncDao {

    private ConfigReader<List<Sync>> reader;
    private ConfigWriter<List<Sync>> writer;

    public SyncDao(ConfigReader<List<Sync>> reader, ConfigWriter<List<Sync>> writer) {
        this.reader = reader;
        this.writer = writer;
    }

    public void saveSyncs(List<Sync> syncs) throws CoreException {
        writer.save(syncs);
    }

    public List<Sync> getSyncs() {

        List<Sync> syncs = reader.read();
        if (syncs == null)
            syncs = new ArrayList<Sync>();

        return syncs;
    }

    public void deleteSyncs() throws CoreException {
        writer.save(new ArrayList<Sync>());
    }


}
