package org.syncloud.facade.dao.io;

import org.apache.commons.io.IOUtils;
import syncloud.core.log.Logger;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

public class ClasspathReader implements Reader {

    private static Logger logger = Logger.getLogger(ClasspathReader.class);
    private String resource;

    public ClasspathReader(String resource) {
        this.resource = resource;
    }

    public String read() {
        String result = null;
        try {
            InputStream is = getClass().getClassLoader().getResourceAsStream(resource);

            if (is == null) {
                logger.error("resource '" + resource + "' is not found  in classpath");
                return result;
            }

            result = IOUtils.toString(is);
            IOUtils.closeQuietly(is);
        } catch (IOException e) {
            logger.error("unable to read " + resource + " from classpath", e);
        }
        return result;
    }

    @Override
    public boolean exists() {
        URL res = getClass().getClassLoader().getResource(resource);

        if (res == null) {
            logger.error("resource '" + resource + "' is not found  in classpath");
            return false;
        } else {
            return true;
        }
    }
}
