package org.syncloud.facade.dao.io;

import org.apache.commons.io.FileUtils;
import syncloud.core.CoreException;
import syncloud.core.log.Logger;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

public class FileReader implements Reader {

    private static Logger logger = Logger.getLogger(FileReader.class);

    private File file;

    public FileReader(String folder, String file) {
        this.file = new File(folder, file);
    }

    @Override
    public String read() {

        try {
            return FileUtils.readFileToString(file);
        } catch (FileNotFoundException e) {
            String message = "file not found: " + file.getPath();
            logger.error(message, e);
            throw new CoreException(message);
        } catch (IOException e) {
            String message = "unable to read file: " + file.getPath();
            logger.error(message, e);
            throw new CoreException(message);
        }
    }

    @Override
    public boolean exists() {
        boolean exists = file.exists();
        if (!exists)
            logger.info("config file is not found: " + file.getAbsolutePath());

        return exists;
    }

}
