package org.syncloud.facade.dao.io;

import org.apache.commons.io.FileUtils;
import syncloud.core.log.Logger;

import java.io.File;
import java.io.IOException;

public class FileWriter {

    private static Logger logger = Logger.getLogger(FileWriter.class);


    private String filename;
    private File folder;

    public FileWriter(String folder, String file) {
        this.filename = file;
        this.folder = new File(folder);
    }

    public void write(String content) throws IOException {


        if (!folder.exists()) {
            logger.debug("creating folder: " + folder.getPath());
            folder.mkdirs();
        }

        File file = new File(folder, filename);
        if (!file.exists()) {
            logger.debug(String.format("creating file: %s in folder: %s", file.getName(), folder.getPath()));
            file.createNewFile();
        }

        FileUtils.writeStringToFile(file, content);
    }
}
