package org.syncloud.facade.dao.json;

import org.json.JSONException;
import org.json.JSONObject;
import org.syncloud.facade.dao.json.base.Parser;
import syncloud.core.CoreException;
import syncloud.storage.UserConfig;

public class UserConfigJsonParser implements Parser<UserConfig, String> {
    public static final String RUN_ON_STARTUP = "run_on_startup";
    public static final String RUN_WEB_SERVER = "run_web_server";
    public static final String WEB_SERVER_PORT = "web_server_port";
    public static final String SYNC_PERIOD = "sync_period";

    public UserConfig fromJson(String json) throws JSONException, CoreException {

        JSONObject jsonObject = new JSONObject(json);
        UserConfig config = new UserConfig();
        config.setRunWebServer(jsonObject.getBoolean(RUN_WEB_SERVER));
        config.setWebServerPort(jsonObject.getInt(WEB_SERVER_PORT));
        config.setSyncPeriod(jsonObject.getInt(SYNC_PERIOD));
        return config;
    }

    public String toJson(UserConfig config) throws JSONException {
        JSONObject json = new JSONObject();
        json.put(RUN_WEB_SERVER, config.isRunWebServer());
        json.put(WEB_SERVER_PORT, config.getWebServerPort());
        json.put(SYNC_PERIOD, config.getSyncPeriod());
        return json.toString();
    }
}
