package org.syncloud.facade.proxy;

import syncloud.storage.IFolder;
import syncloud.storage.INode;
import syncloud.storage.NodeKey;
import syncloud.storage.StorageKey;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CachingFoldersProxy implements FoldersProxy {
    private Map<StorageKey, Map<NodeKey, IFolder>> cache = new HashMap<StorageKey, Map<NodeKey, IFolder>>();
    private FoldersProxy proxy;

    public CachingFoldersProxy(FoldersProxy proxy) {
        this.proxy = proxy;
    }

    @Override
    public List<IFolder> getFolders(NodeKey nodeKey) {

        /*List<IFolder> contents = proxy.getFolder(nodeKey).getFolders();
        addToCache(nodeKey.getStorageKey(), contents);
        return contents;*/
        return null;
    }

    private <T extends INode> void addToCache(StorageKey key, List<T> nodes) {
        for (INode node : nodes)
            if (node instanceof IFolder) {
                if (!cache.containsKey(key))
                    cache.put(key, new HashMap<NodeKey, IFolder>());
                cache.get(key).put(node.getKey(), (IFolder) node);
            }
    }

    private IFolder getFromCache(NodeKey storagePathKey) {
        return cache.get(storagePathKey.getStorageKey()).get(storagePathKey);
    }

    private boolean cached(NodeKey storagePathKey) {
        return cache.containsKey(storagePathKey.getStorageKey()) && cache.get(storagePathKey.getStorageKey()).containsKey(storagePathKey);
    }
}
